package uulm.teamname.marvelous.server.netconnector;

import org.java_websocket.WebSocket;
import org.java_websocket.handshake.ClientHandshake;
import org.java_websocket.server.WebSocketServer;
import org.tinylog.Logger;
import uulm.teamname.marvelous.gamelibrary.json.JSON;

import java.net.InetSocketAddress;

public class MarvelousServer extends WebSocketServer {
    @Override
    public void onOpen(WebSocket conn, ClientHandshake handshake) {
        Logger.info("New client connected. Adding new User.");
        userManager.connectUser(conn, handshake);
        // TODO: Send messages to UserManager, which then packages that stuff and sends it further
    }

    @Override
    public void onClose(WebSocket conn, int code, String reason, boolean remote) {
        Logger.info("Client disconnected");
        userManager.disconnectUser(conn, remote);
        // TODO: Send messages to UserManager, which then removes the user and such
    }

    @Override
    public void onMessage(WebSocket conn, String message) {
        Logger.debug("Message received: {}", message);
        userManager.messageReceived(conn, message);
        // TODO: Send messages to UserManager, which then packages them and sends them further
    }

    @Override
    public void onError(WebSocket conn, Exception ex) {
        // TODO: Send errors to UserManager, which then answers with even more errors
    }

    @Override
    public void onStart() {
        // TODO: Get the UserManager, and tell it that this thing is active
    }

    private final UserManager userManager;

    public MarvelousServer(InetSocketAddress address, JSON json) {
        super(address);
        this.userManager = new UserManager(json);
    }

    /** Practically No-Arg constructor for testing. <b>NEVER USE ANYWHERE ELSE!</b>
     * @param userManager*/
    protected MarvelousServer(UserManager userManager) { super();
        this.userManager = userManager;
    }
}
